#include "dcel.h"
#include "circular.h"
#include "relation.h"

#ifndef TRUE
typedef int bool;
#define TRUE 1
#define FALSE 0
#endif

lptr mark_list=NULL,f_mark_list=NULL,v_mark_list=NULL;


bool MARK(e)
eptr e;
{
 if (e!=NULL)
 {
  e->mark=TRUE;
  INSERT_CLOCK(&mark_list,(iptr)e);
  return(TRUE);
 }
 return(FALSE);
}

bool CANCEL_MARK(i)
iptr i;
{
 lptr auxdel;

 if (mark_list->this == i)
 {
  if ((mark_list == mark_list->clock) &&
     (mark_list == mark_list->counterclock))
  {
   FREELIST(&mark_list);
   return(TRUE);
  }
  else
  {
   mark_list->counterclock->clock = mark_list->clock;
   mark_list->clock->counterclock = mark_list->counterclock;
   auxdel = mark_list;
   mark_list = mark_list->counterclock;
   free((char *)auxdel);
   return(TRUE);
  }
 }
 else return(FALSE);
}

bool IS_MARKED(e)
eptr e;
{
 if (e!=NULL)
  return(e->mark);
 else
  return(FALSE);
}

bool RESET_MARK()
{
 eptr e; lptr el1;

 if (mark_list!=NULL)
 {
  el1=MARK_POSITION(mark_list);
  do
  {
   e=(eptr)FIRST(mark_list);
   e->mark=FALSE;
   CLOCKWISE(&mark_list);
  } while (!SAME_POSITION(mark_list,el1));
  FREELIST(&mark_list);
  return(TRUE);
 }
 return(FALSE);
}

bool F_MARK(f)
fptr f;
{
 if (f!=NULL)
 {
  f->mark=TRUE;
  INSERT_CLOCK(&f_mark_list,(iptr)f);
  return(TRUE);
 }
 return(FALSE);
}

bool F_UNMARK(f)
fptr f;
{
 if (f!=NULL)
 {
  f->mark=FALSE;
  return(TRUE);
 }
 return(FALSE);
 }

bool F_MARKED(f)
fptr f;
{
 if (f!=NULL)
  return(f->mark);
 else
  return(FALSE);
}

bool F_RESET_MARK()
{
 fptr f;lptr fl1;

 if (EMPTY(f_mark_list)) return(FALSE);
 fl1=MARK_POSITION(f_mark_list);
 do
 {
  f=(fptr)FIRST(f_mark_list);
  f->mark=FALSE;
  CLOCKWISE(&f_mark_list);
 } while (!SAME_POSITION(f_mark_list,fl1));
 FREELIST(&f_mark_list);
 return(TRUE);
}

bool V_MARK(v)
vptr v;
{
 if (v!=NULL)
 {
  v->mark=TRUE;
  INSERT_CLOCK(&v_mark_list,(iptr)v);
  return(TRUE);
 }
 return(FALSE);
}

bool V_UNMARK(v)
vptr v;
{
 if (v!=NULL)
 {
  v->mark=FALSE;
  return(TRUE);
 }
 return(FALSE);
}

bool V_MARKED(v)
vptr v;
{
 if (v!=NULL)
  return(v->mark);
 else
  return(FALSE);
}

bool V_RESET_MARK()
{
 vptr v;lptr vl1;

 if (EMPTY(v_mark_list)) return(FALSE);
 vl1=MARK_POSITION(v_mark_list);
 do
 {
  v=(vptr)FIRST(v_mark_list);
  v->mark=FALSE;
  CLOCKWISE(&v_mark_list);
 } while (!SAME_POSITION(v_mark_list,vl1));
 FREELIST(&v_mark_list);
 return(TRUE);
}

bool SET_CONSTRAINT_EDGE(s,e)
sptr s;eptr e;
{
 if (IS_AN_EDGE(s,e))
  e->constraint=TRUE;
 else
  return(FALSE);
 return(TRUE);
}

bool IS_A_CONSTRAINT(s,e)
sptr s; eptr e;
{
 if (IS_AN_EDGE(s,e))
  return(e->constraint);
 else
  return(FALSE);
}
