        /* Primitive operations for doubly connected circular lists */
#ifndef NULL
#define NULL 0
#endif

#ifndef TRUE
typedef int bool;
#define TRUE 1
#define FALSE 0
#endif

typedef int itemtype, *iptr;

typedef struct list {
                     iptr this;
                     struct list *clock,*counterclock;
                    } list, *lptr;

/* private low-level functions */

static lptr new_element(i)
iptr i;
{
 lptr aux;

 if (i == NULL) return(NULL);
 if ((aux = (lptr) malloc(sizeof(list))) == NULL) return(NULL);
 aux->this = i;
 aux->clock = NULL;
 aux->counterclock = NULL;
 return(aux);
}

/* list management functions */

void INIT(L)
lptr *L;
{
 *L = NULL;
}

bool INSERT_CLOCK(L,I)
lptr *L; iptr I;
{
 lptr l1, pos = *L;

 if ((l1 = new_element(I)) == NULL) return(FALSE);
 if (pos == NULL)
 {
  l1->clock=l1;
  l1->counterclock=l1;
 }
 else
 {
  l1->clock=pos->clock;
  l1->counterclock=pos;
  pos->clock=l1;
  l1->clock->counterclock=l1;
 }
 *L=l1;
 return(TRUE);
}

bool INSERT_COUNTERCLOCK(L,I)
lptr *L; iptr I;
{
 lptr l1, pos = *L;

 if ((l1 = new_element(I)) == NULL) return(FALSE);
 if (pos == NULL)
 {
  l1->clock=l1;
  l1->counterclock=l1;
 }
 else
 {
  l1->counterclock=pos->counterclock;
  l1->clock=pos;
  pos->counterclock=l1;
  l1->counterclock->clock=l1;
 }
 *L=l1;
 return(TRUE);
}

bool CANCEL(L,I)
lptr *L; iptr I;
{
 lptr curr = *L, pos = *L;

 if (curr == NULL || I == NULL) return(FALSE);
 if (curr->this == I)
 {
  curr->clock->counterclock = curr->counterclock;
  curr->counterclock->clock = curr->clock;
  if (curr->clock == curr)
    *L = NULL;
  else
    *L = curr->clock;
  free((char *)curr);
  return(TRUE);
 }
 for (pos = pos->clock; pos != curr; pos = pos->clock)
  if (pos->this == I)
  {
   pos->clock->counterclock = pos->counterclock;
   pos->counterclock->clock = pos->clock;
   free((char *)pos);
   return(TRUE);
  }
 return(FALSE);
}

void FREELIST(L)
lptr *L;
{
 lptr l1, l2 = (*L);

 if (l2 != NULL)
  for (l1=l2->clock,l2->clock = NULL; l1 != NULL; l1=l2)
  {
   l2=l1->clock;
   free((char *)l1);
  }
 (*L)=NULL;
}

lptr IS_ELEMENT(L,I)
lptr L; iptr I;
{
 lptr pos = L->clock;

 if (L == NULL || I == NULL) return(NULL);
 for (; pos != L && pos->this != I; pos = pos->clock);
 if (pos->this == I)
   return(pos);
 else return(NULL);
}

bool EMPTY(L)
lptr L;
{
 return(L == NULL);
}

iptr FIRST(L)
lptr L;
{
 if (L==NULL) return(NULL);
 else return(L->this);
}

lptr CLOCKWISE(L)
lptr *L;
{
 lptr curr = *L;

 if (curr == NULL)
   return(NULL);
 else
 {
  *L=curr->clock;
  return(*L);
 }
}

lptr COUNTERCLOCK(L)
lptr *L;
{
 lptr curr = *L;

 if (*L == NULL)
   return(NULL);
 else
 {
  *L=curr->counterclock;
  return(*L);
 }
}

lptr MARK_POSITION(L)
lptr L;
{
 return(L);
}

bool SAME_POSITION(L,M)
lptr L, M;
{
 return(L == M);
}
