      /* Extended DCEL data structure for piecewise linear surfaces */
#ifndef dcel
#define dcel
 
#ifndef TRUE
typedef int bool;
#define TRUE 1
#define FALSE 0
#endif

typedef struct surface {
                        struct vertex *vlist;
                        struct edge *elist;
                        struct face *flist, *infinity;
                       } surface, *sptr;

typedef struct edge {
                     struct edge *next,*prev;
                     struct vertex *vertices[2];
                     struct face *faces[2];
                     struct edge *edges[2];
                     struct surface *structure;
                     bool mark,constraint;
                    } edge, *eptr;

typedef struct vertex {
                       struct vertex *next,*prev;
                       struct edge *incidentedge;
                       double x,y;
                       bool mark;
                      } vertex, *vptr;

typedef struct face {
                     struct face *next,*prev;
                     struct edge *boundingedge;
                     double xc,yc,rc;    /* only for triangulations */
                     bool mark;
                    } face, *fptr;

#endif
