       /* Construction primitive operations (Euler's operators) */
#ifndef euler
#define euler

extern bool MAKE_VERTEX_INFINITY_FACE();
/* initializes surface s by inserting vertex v of
   coordinates (x,y) and creating infinity face f */

extern bool MAKE_EDGE_VERTEX();
/* creates a new edge e in s, connecting vertex v of s with
   new vertex vn of coordinates (x,y) */

extern bool MAKE_EDGE_FACE();
/* splits face fo of s by a new edge e connecting vertices v0
   and v1; a new face fn is created to the left of vector v1-v0 */
/* WARNING: when splitting infinity face, v0 and v1 must be ordered
   so that fo corresponds to infinity face also after the operation */

extern bool MAKE_EDGE_BOUND_FACE();
/* splits face fo of s by a new edge e connecting vertices v0
   and v1; a new face fn is created to the left of vector v1-v0 */
/* WARNING: when splitting infinity face, v0 and v1 must be ordered
   so that fo corresponds to infinity face also after the operation */

extern bool KILL_EDGE_FACE();
/* deletes face f and edge e from tassellation s */

extern bool KILL_EDGE_VERTEX();
/* deletes edge e and vertex v from tassellation s */

extern bool KILL_VERTEX_INFINITY_FACE();
/* deletes last vertex v and infinity face from tessellation s */

extern bool SWAP_EDGE();
/* if f and f1 are triangles of s adjacent along e, swap e with the other
   diagonal of the quadrilateral formed by f and f1 */

#endif
