            /* Access primitives for 2D tesselations based on DCEL */
#ifndef relation
#define relation


/* Query primitive functions */

extern bool IS_AN_EDGE();

extern bool IS_A_VERTEX();

extern bool IS_A_FACE();

extern bool IS_A_TRIANGLE();

extern bool IS_INCIDENT();

extern bool IS_BOUNDING();

extern bool IS_BOUNDARY();

extern bool IS_ISOLATED();

extern bool IS_DANGLING_VERTEX();

extern bool IS_DANGLING_EDGE();

extern bool IS_INFINITY_FACE();


/* Structure scan functions */

extern bool COORDINATES();

extern vptr FIRST_VERTEX();

extern vptr NEXT_VERTEX();

extern vptr PREV_VERTEX();

extern eptr FIRST_EDGE();

extern eptr NEXT_EDGE();

extern eptr PREV_EDGE();

extern fptr FIRST_FACE();

extern fptr NEXT_FACE();

extern fptr PREV_FACE();

extern fptr INFINITY_FACE();


/* Relation primitive functions */

extern bool EDGE_EDGE();

extern bool EDGE_VERTEX();

extern bool EDGE_FACE();

extern lptr FACE_EDGE();

extern lptr FACE_VERTEX();

extern lptr FACE_FACE();

extern lptr VERTEX_EDGE();

extern lptr VERTEX_VERTEX();

extern lptr VERTEX_FACE();


/* Partial relations */

extern bool EXTREME_VERTICES();

extern vptr COMMON_VERTEX();

extern eptr COMMON_EDGE();

extern fptr OTHER_FACE();

extern vptr OTHER_VERTEX();

extern eptr FIRST_BOUNDING_EDGE();

extern eptr NEXT_CLOCK_EDGE();

extern eptr CLOCK_INCIDENT_EDGE();

extern vptr OPPOSITE_VERTEX();

#endif
